;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Soft Scheme - Copyright (c) 1993,1994 by Andrew K. Wright
;; See LICENSE for a full description of the license terms.


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Soft Type reconstruction for Scheme, Chez version

;; Installation options:
(eval-when (compile load eval)

;; match-file must be an absolute pathname or #f
(define match-file #f)

;; installation directory must be an absolute pathname ending in a slash
(define installation-directory "/pls/accts/wright/soft/scheme/")

;; customization-file must be a path relative to installation-directory, or #f
(define customization-file "custom-chez.scm")

;; fastlibrary-file must be a path relative to installation-directory, or #f
(define fastlibrary-file "fastlib-chez.scm")
)

;;;;;;;;;;;;;;;;

(define st:version "CHEZ Version 0.18, April 21, 1995")

(eval-when (compile load eval)
  (case-sensitive #t) ; recommended but not essential
  (print-graph #f)
  (print-gensym #f)
  (and match-file (load match-file))
  (when (top-level-bound? 'eps-expand-once)
    (set! expand-once eps-expand-once)))

(eval-when (compile)
  (optimize-level 3))

(define home-directory "~")

(**INCLUDE** "encapsulate.scm")

(**INCLUDE** "basiclib-chez.scm")
(**INCLUDE** "checklib.scm")

(encapsulate
  (st:help st: st:check st:run st:bench st:type st:ltype st:cause st:control st:summary st:defprim st:deftype)

  ("intro-chez.scm"

    "library.scm"
    "data.scm"

    "parse.scm"
    "macros.scm"
    "env.scm"

    "types.scm"
    "tidy.scm"
    "init.scm"
    "prim.scm"

    "bind.scm"
    "improve.scm"
    "improve-match.scm"

    "components.scm"
    "top-sort.scm"

    "typechk.scm"

    "unparse.scm"
    "display-check.scm"
    "display-cause.scm"
    "display-type.scm"

    "drivers.scm")
  
  (init!))
